var TCF_COOKIE_KEY = 'borosTcf';

var readCookie = function readCookie(key, cookies) {
  var re = new RegExp(key + '=([^;]+)');
  var value = re.exec(cookies);
  return value !== null ? value[1] : null;
};

export var isUserFirstVisit = function isUserFirstVisit(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      cookies = _ref.cookies;

  var cookieValue = readCookie(TCF_COOKIE_KEY, cookies);
  return cookieValue === null;
};

var integrationsAreDeactivated = function integrationsAreDeactivated(integrations) {
  return integrations.All === false;
};

var defaultIsFirstVisit = isUserFirstVisit({
  cookies: document.cookie
}); // We only want to track in GTM those events who have
// been tracked by the backend already

export var gtmOnlyMiddleware = function gtmOnlyMiddleware(_ref2) {
  var payload = _ref2.payload,
      next = _ref2.next,
      _ref2$isFirstVisit = _ref2.isFirstVisit,
      isFirstVisit = _ref2$isFirstVisit === void 0 ? defaultIsFirstVisit : _ref2$isFirstVisit;
  var _payload$obj = payload.obj,
      integrations = _payload$obj.integrations,
      event = _payload$obj.event;
  var isPageView = event.endsWith('Viewed');

  if (integrationsAreDeactivated(integrations) || !isPageView) {
    return next(payload);
  }

  if (isFirstVisit) {
    return next(payload);
  } // activates GTM only


  payload.obj.integrations = {
    All: false,
    'Google Tag Manager': true
  };
  next(payload);
};